#!/usr/bin/perl -w
use strict;

my %supervise;
my %count_pupil;
open(PERSON,"person_link.txt");
while(<PERSON>) {
    chomp;
    my ($person, $supervisor, $pupil, $collaborator) = split(/\t/);
    if( $supervisor ) {
        $supervise{$supervisor}->{$person} = 1;
    }
    if( $pupil ) {
        $supervise{$person}->{$pupil} = 1;
        if( exists $count_pupil{$person} ) {
            $count_pupil{$person}++;
        } else {
            $count_pupil{$person} = 1;
        }
    }
}
close(PERSON);

print "digraph G{\n";
foreach my $tmp_p1 (keys %supervise) {
    foreach my $tmp_p2 (keys %{$supervise{$tmp_p1}}) {
        if( exists $count_pupil{$tmp_p1} && $count_pupil{$tmp_p1} > 5
            && $tmp_p2 
            && exists $count_pupil{$tmp_p2} && $count_pupil{$tmp_p2} > 1 ) {
            print "\"$tmp_p1\" -> \"$tmp_p2\";\n";
        }
    }
}
print "}";
