#!/usr/bin/perl -w
use strict;
use Ace;

## Turn off output caching
$| = 9;

my $acedb = do "../etc/acedb.pl";
my $conf  = do "../etc/wormi.pl";

my %wormpep;
my $file_prot = $conf->{DIR_WORMI}.$conf->{DIR_WORMBASE_DATA}
                .sprintf($conf->{FILE_WS_BLAST_HITS},$conf->{WORMBASE_VER});
open(PROT,$file_prot);
print STDERR "Read WormPep ID from ",$file_prot,"...\n";
while(<PROT>) {
    chomp;
    my ($wpid,@tmp) = split(/,/);
    $wpid = "WP:".$wpid;
    $wormpep{$wpid} = 1;
}
close(PROT);

print STDERR "Connecting AceDB...";
my $db = Ace->connect(%{$acedb}) || die "Connection failure", Ace->error;
print STDERR " Done!\n";

my $file_output = $conf->{DIR_WORMI}.$conf->{DIR_WORMBASE_DATA}
                .$conf->{FILE_WS_CDS}.".".$conf->{WORMBASE_VER}.".txt";

open(CDS,">$file_output");
print STDERR "Write ",$file_output,"...\n";
foreach my $tmp_wpid (sort keys %wormpep) {
#my $tmp_wpid = "WP:CE23248"; {
    my $tmp_prot = $db->fetch(Protein => $tmp_wpid ) || die Ace->error;

    if( my $corresponding_cds = $tmp_prot->Corresponding_CDS() ) {
        my $cds = $db->fetch(CDS=>$tmp_prot->get('Corresponding_CDS'));
        if( $cds->Brief_identification() ) {
            print CDS $tmp_wpid,"\t",$corresponding_cds,"\t",
                $cds->get('Brief_identification'),"\n";
        } else {
            print CDS $tmp_wpid,"\t",$corresponding_cds,"\t",
                "not_available\n";
        }
    }
}
close(CDS);
