#!/usr/bin/perl -w
use strict;
use Ace;

## Turn off output caching
$| = 9;

my $acedb = do "../etc/acedb.pl";
my $conf  = do "../etc/wormi.pl";

my %wormpep;
my $file_prot = $conf->{DIR_WORMI}.$conf->{DIR_WORMBASE_DATA}
                .sprintf($conf->{FILE_WS_BLAST_HITS},$conf->{WORMBASE_VER});
open(PROT,$file_prot);
print STDERR "Read WormPep ID from ",$file_prot,"...\n";
while(<PROT>) {
    chomp;
    my ($wpid,@tmp) = split(/,/);
    $wpid = "WP:".$wpid;
    $wormpep{$wpid} = 1;
}
close(PROT);

print STDERR "Connecting AceDB...";
my $db = Ace->connect(%{$acedb}) || die "Connection failure", Ace->error;
print STDERR " Done!\n";

my $file_output = $conf->{DIR_WORMI}.$conf->{DIR_WORMBASE_DATA}
                .$conf->{FILE_WS_PEP_MOTIF}.".".$conf->{WORMBASE_VER}.".txt";

open(DOMAIN,">$file_output");
print STDERR "Write ",$file_output,"...\n";
foreach my $tmp_wpid (sort keys %wormpep) {
    my $tmp_prot = $db->fetch(Protein => $tmp_wpid ) || die Ace->error;

    if( my @motif_homol = $tmp_prot->get('Motif_homol') ) {
        foreach my $tmp_motif (@motif_homol) {
            my $motif = $db->fetch(Motif=>$tmp_motif);
            print DOMAIN $tmp_motif,"\t", $motif->get('Title'),"\t", $tmp_wpid,"\n";
        }
    }
}
close(DOMAIN);
