#!/usr/bin/perl -w
use strict;
use Ace;

## Turn off output caching
$! = 9;

my $acedb = do "../etc/acedb.pl";
my $conf = do "../etc/wormi.pl";

my %wormgene;
my $file_gene = $conf->{DIR_WORMI}.$conf->{DIR_WORMBASE_DATA}
                .sprintf($conf->{FILE_WS_GENEID}, $conf->{WORMBASE_VER});
open(GENE,$file_gene);
print STDERR "Read WormGene ID from ",$file_gene,"...\n";
while(<GENE>) {
    chomp;
    my ($geneid,@tmp) = split(/,/);
    $wormgene{$geneid} = 1;
}
close(GENE);

print STDERR "Connecting AceDB...";
my $db = Ace->connect(%{$acedb}) || die "Connection failure", Ace->error;
print STDERR " Done!\n";

my $file_output = $conf->{DIR_WORMI}.$conf->{DIR_WORMBASE_DATA}
                .$conf->{FILE_WS_EXPR_PATTERN}.".".$conf->{WORMBASE_VER}.".txt";

open(EXPR,">$file_output");
print STDERR "Write ",$file_output,"...\n";
foreach my $tmp_wg (sort keys %wormgene) {
    my $tmp_gene = $db->fetch(Gene => $tmp_wg) || die Ace->error;
    if( $tmp_gene->get('Expr_pattern') ) {
        my @exprs = $tmp_gene->get('Expr_pattern');
        foreach my $expr (@exprs) {
            my $tmp_expr = $db->fetch(Expr_pattern => $expr);
            my @life_stages = $tmp_expr->get('Life_stage');
            foreach my $life_stage (@life_stages) {
                print EXPR $tmp_gene,"\t",$tmp_expr,"\t",
                    $tmp_expr->get('Pattern'),"\t", $life_stage,"\n";
            }
        }
    }
}
close(EXPR);
