#!/usr/bin/perl -w
use strict;

use LWP::UserAgent;
my $ua = new LWP::UserAgent;

my $conf = do "../etc/wormi.pl";
my $ace_query = do "../etc/acequery.pl";

$ua->env_proxy;
my $aql_form = { aql => $ace_query->{fetch_mut_phenotype},
                 format => "Text output" };

my $response = $ua->post($conf->{URL_AQL_QUERY}, $aql_form );

if( $response->is_success ) {
    my $file_output = $conf->{DIR_WORMI}."/".$conf->{DIR_WORMBASE_DATA}."/"
                .$conf->{FILE_WS_MUT_PHENOTYPE}.".".$conf->{WORMBASE_VER}
                .".txt";
    open(BID,">$file_output");
    print BID $response->content;
    close(BID);
} else {
    die $response->status_line;
}
