#!/usr/bin/perl -w
use strict;
use Ace;

## Turn off output caching
$! = 9;

my $acedb = do "../etc/acedb.pl";
my $conf = do "../etc/wormi.pl";

my %wormpaper;
my $file_rnai = $conf->{DIR_WORMI}.$conf->{DIR_WORMBASE_DATA}
                .$conf->{FILE_WS_RNAI}.".". $conf->{WORMBASE_VER}.".txt";
open(RNAI,$file_rnai);
print STDERR "Read WormPaper ID from ",$file_rnai,"...\n";
while(<RNAI>) {
    chomp;
    my @tmp = split(/\t/);
    $wormpaper{$tmp[5]} = 1;
}
close(RNAI);

print STDERR "Connecting AceDB...";
my $db = Ace->connect(%{$acedb}) || die "Connection failure", Ace->error;
print STDERR " Done!\n";

my $file_output = $conf->{DIR_WORMI}.$conf->{DIR_WORMBASE_DATA}
                .$conf->{FILE_WS_PAPER}.".".$conf->{WORMBASE_VER}.".txt";

open(PAPER,">$file_output");
print STDERR "Write ",$file_output,"...\n";
foreach my $tmp_wp (sort keys %wormpaper) {
    my $tmp_paper = $db->fetch(Paper => $tmp_wp) || die Ace->error;
    print PAPER $tmp_paper, "\t", $tmp_paper->Author, "\t",
            $tmp_paper->Year,"\t", $tmp_paper->Brief_citation,"\n";
}
close(PAPER);
