#!/usr/bin/perl -w
use strict;

use LWP::UserAgent;
my $ua = new LWP::UserAgent;
my $conf = do "../etc/wormi.pl";

$ua->env_proxy;

## WS_GFF, WS_GO, WS_BLAST_HITS, WS_FUNCTION, WS_GENEID
foreach my $tmp_ws ("WS_GO","WS_BLAST_HITS", "WS_GFF"
                        ,"WS_FUNCTION", "WS_GENEID") {
    my $tag_file = "FILE_".$tmp_ws;
    my $tag_dir  = "DIR_".$tmp_ws;

    my $ws_file = sprintf($conf->{$tag_file}, $conf->{WORMBASE_VER});
    my $url_file = $conf->{URL_FTP_WORMBASE}.$conf->{$tag_dir}.$ws_file.".gz";
    
    print STDERR "Get ",$url_file,"\n";
    my $response = $ua->get($url_file);
    
    if( $response->is_success ) {
        my $wi_file = $conf->{DIR_WORMI}.$conf->{DIR_WORMBASE_DATA}.$ws_file
                        .".gz";
        print STDERR $wi_file,"\n";
        open(OUT,">$wi_file");
        print OUT $response->content;
        close(OUT);
        `gunzip $wi_file`;
        
        if( $tmp_ws eq "WS_GFF" ) {
            $wi_file =~ s/\.gz$//;
            my %split_gff;
            open(GFF, $wi_file);
            while(my $line = <GFF>) {
                chomp($line);
                my @tmp = split(/\t/,$line);
                push(@{$split_gff{$tmp[2]}}, $line);
            }
            close(GFF);

            my $wi_file_tmpl = $wi_file;
            $wi_file_tmpl =~ s/\.gff/\.\%s\.gff/;
            foreach my $tmp_src (keys %split_gff) {
                my $wi_file_split = sprintf($wi_file_tmpl, $tmp_src);
                print STDERR $wi_file_split,"\n";
                open(SPLIT, ">$wi_file_split");
                print SPLIT join("\n", @{$split_gff{$tmp_src}});
                close(SPLIT);
            }
        }
    } else {
        die $response->status_line;
    }
}

## PCR_PRODUCT, specially from sanger ftp site
my $url_file = sprintf($conf->{URL_FTP_SANGER}, 
                        $conf->{WORMBASE_VER}, $conf->{WORMBASE_VER})
                . sprintf($conf->{FILE_WS_PCR}, $conf->{WORMBASE_VER}).".gz";
my $r_sanger = $ua->get($url_file);
if( $r_sanger->is_success ) {
    my $wi_file = $conf->{DIR_WORMI}.$conf->{DIR_WORMBASE_DATA}
                    . sprintf($conf->{FILE_WS_PCR}, $conf->{WORMBASE_VER}).".gz";
    print STDERR $wi_file,"\n";
    open(OUT, ">$wi_file");
    print OUT $r_sanger->content;
    close(OUT);
    `gunzip $wi_file`;
} else {
    die $r_sanger->status_line;
}

