#!/usr/bin/perl -w
use strict;

## Domain
## WBPepID, domainDB, domainDBID, domainDescription, sourceDB

my $conf = do "../etc/wormi.pl";
my @tmp_ts = localtime(time());
my $timestamp = sprintf("%02d%02d%02d",$tmp_ts[3],$tmp_ts[4]+1,$tmp_ts[5]%100);

my $WS_DOM_FILE = $conf->{DIR_WORMI}. $conf->{DIR_WORMBASE_DATA}
                . $conf->{FILE_WS_PEP_MOTIF}.".". $conf->{WORMBASE_VER} .".txt";
my $DOM_OUT_FILE = $conf->{DIR_WORMI}. $conf->{DIR_WORMI_DATA}
                . $conf->{FILE_WORMI_DOMAIN}.".".$timestamp."."
                . $conf->{WORMBASE_VER}.".txt" ;

open(DOMI,$WS_DOM_FILE);
print STDERR "Read ",$WS_DOM_FILE,"...\n";
open(DOMO,">$DOM_OUT_FILE");
print STDERR "Write ",$DOM_OUT_FILE,"...\n";
while(<DOMI>) {
    chomp;
    my ($domainInfo, $domainDesc, $wbpepID) = split(/\t/);
    my ($domainDB, $domainDBID) = split(/\:/, $domainInfo);

    ## Only C. elegans proteins
    if( $wbpepID =~ /^WP/ ) {
        print DOMO $wbpepID,"\t",$domainDB,"\t",$domainDBID,"\t",$domainDesc
            ,"\t",$conf->{WORMBASE_VER},"\n";
    }
}
close(DOMI);
close(DOMO);
