#!/usr/bin/perl -w

## MutPhenotype
## WBGeneID, phenotypeDescription, sourceDB

my $conf = do "../etc/wormi.pl";
my @tmp_ts = localtime(time());
my $timestamp = sprintf("%02d%02d%02d",$tmp_ts[3],$tmp_ts[4]+1,$tmp_ts[5]%100);

my $WS_MUT_PHE_FILE = $conf->{DIR_WORMI}. $conf->{DIR_WORMBASE_DATA}
                . $conf->{FILE_WS_MUT_PHENOTYPE}.".". $conf->{WORMBASE_VER} 
                .".txt";
my $WI_MUT_PHE_FILE = $conf->{DIR_WORMI}. $conf->{DIR_WORMI_DATA}
                . $conf->{FILE_WORMI_MUT_PHENOTYPE}.".".$timestamp."."
                . $conf->{WORMBASE_VER}.".txt";

open(MPI,$WS_MUT_PHE_FILE);
print STDERR "Read ",$WS_MUT_PHE_FILE,"...\n";
open(MPO,">$WI_MUT_PHE_FILE");
print STDERR "Write ",$WI_MUT_PHE_FILE,"...\n";
while(<MPI>) {
    chomp;
    my ($gene_id, $phenotype) = split(/\t/);
    next unless ($phenotype);
    print MPO $gene_id,"\t", $phenotype,"\t", $conf->{WORMBASE_VER},"\n";
}
close(MPO);
close(MPI);
