#!/usr/bin/perl -w
use strict;

my $conf = do "../etc/wormi.pl";

my $DIR_WI = $conf->{DIR_WORMI}. $conf->{DIR_WORMI_DATA};

my %reagent_list;
my $FILE_REAGENT 
        = `ls $DIR_WI$conf->{FILE_WORMI_REAGENT}.*.$conf->{WORMBASE_VER}.txt`;
chomp($FILE_REAGENT);
my $FILE_REAGENT_NEW = $FILE_REAGENT;
$FILE_REAGENT_NEW =~ s/txt/updated\.txt/;
print STDERR "Update ",$FILE_REAGENT,"...\n";
open(REAGENTO, ">$FILE_REAGENT_NEW");
open(REAGENTI, $FILE_REAGENT);
while(<REAGENTI>) {
    chomp;
    my ($reagentName, $reagentType, $reagentTemplate, $sourceDB) = split(/\t/);
    $reagentName = &update_reagent($reagentName);
    if( exists $reagent_list{$reagentName} ) { next; }
    else { $reagent_list{$reagentName} = 1; }

    print REAGENTO $reagentName,"\t",$reagentType,"\t", $reagentTemplate,"\t",
            $sourceDB,"\n";
}
close(REAGENTI);
close(REAGENTO);

my $FILE_REAGENT_GENE = `ls $DIR_WI$conf->{FILE_WORMI_REAGENT_GENE}.*.$conf->{WORMBASE_VER}.txt`;
chomp($FILE_REAGENT_GENE);
my $FILE_REAGENT_GENE_NEW = $FILE_REAGENT_GENE;
$FILE_REAGENT_GENE_NEW =~ s/txt/updated\.txt/;
print STDERR "Update ",$FILE_REAGENT_GENE,"...\n";
open(RGENEO,">$FILE_REAGENT_GENE_NEW");
open(RGENEI,$FILE_REAGENT_GENE);
while(<RGENEI>) {
    chomp;
    my ($reagentName, $wbreagent, $wbgene, $targetType, $targetPosition, 
        $matchLength, $sourceDB) = split(/\t/);
    $reagentName = &update_reagent($reagentName);
    print RGENEO $reagentName,"\t", $wbreagent,"\t", $wbgene,"\t",
            $targetType,"\t", $targetPosition,"\t",
            $matchLength,"\t", $sourceDB,"\n";
}
close(RGENEI);
close(RGENEO);

my $FILE_LIB_REAGENT = `ls $DIR_WI$conf->{FILE_WORMI_LIB_REAGENT}.*.$conf->{WORMBASE_VER}.txt`;
chomp($FILE_LIB_REAGENT);
my $FILE_LIB_REAGENT_NEW = $FILE_LIB_REAGENT;
$FILE_LIB_REAGENT_NEW =~ s/txt/updated\.txt/;
print STDERR "Update ",$FILE_LIB_REAGENT,"...\n";
open(LIBRO,">$FILE_LIB_REAGENT_NEW");
open(LIBRI,$FILE_LIB_REAGENT);
while(<LIBRI>) {
    chomp;
    my ($reagentName, $libraryName, $plate, $well, $isSequencing, $clone)
        = split(/\t/);
    $reagentName = &update_reagent($reagentName);
    print LIBRO $reagentName,"\t", $libraryName,"\t", $plate,"\t", $well,"\t",
            $isSequencing,"\t", $clone,"\n";
}
close(LIBRI);
close(LIBRO);

my $FILE_EXP_REAGENT = `ls $DIR_WI$conf->{FILE_WORMI_EXP_REAGENT}.*.$conf->{WORMBASE_VER}.txt`;
chomp($FILE_EXP_REAGENT);
my $FILE_EXP_REAGENT_NEW = $FILE_EXP_REAGENT;
$FILE_EXP_REAGENT_NEW =~ s/txt/updated\.txt/;
print STDERR "Update ",$FILE_EXP_REAGENT,"...\n";
open(EXPRO,">$FILE_EXP_REAGENT_NEW");
open(EXPRI,$FILE_EXP_REAGENT);
while(<EXPRI>) {
    chomp;
    my ($reagentName, $libraryName, $experimentName) = split(/\t/);
    $reagentName = &update_reagent($reagentName);
    print EXPRO $reagentName,"\t", $libraryName,"\t", $experimentName,"\n";
}
close(EXPRI);
close(EXPRO);

sub update_reagent {
    my $name = shift;
    if( $name =~ /^sjj/ && $name =~ /_[0-9]+$/) {
        $name =~ s/_[0-9]+$//;
    }
    return $name;
}
