#!/usr/bin/perl -w
use strict;

use lib "../libperl";
use GenomeMap::SVG;
use GenomeMap::IO;

my $svg = new GenomeMap::SVG;
my $io  = new GenomeMap::IO;

my $conf = do "../etc/venn2.pl";

my $LABEL1 = "lin-15A";
my $LABEL2 = "lin-15A + lin-15B";
my $VALUE1 = 15;
my $VALUE2 = 20;
my $VALUE12 = 254;

my $COLOR1 = 'red';
my $COLOR2 = 'blue';
my $COLOR12 = 'green';

## HEADER
print $svg->http_header();
print $svg->header( -width => $conf->{WIDTH}, -height => $conf->{HEIGHT}),"\n";

## TITLE
#print $svg->text( -x => $conf->{TITLE}->{'x'}, -y => $conf->{TITLE}->{'y'},
#                  -text => $TITLE, -size => $conf->{TITLE}->{'font_size'},
#                  -font => $conf->{FONT}),"\n";

## LABEL
print $svg->text( -x => $conf->{ITEM1_LABEL}->{'x'}, 
                  -y => $conf->{ITEM1_LABEL}->{'y'},
                  -font => $conf->{FONT}, -size => $conf->{LABEL_FONT_SIZE},
                  -text => $LABEL1 ),"\n";
print $svg->text( -x => $conf->{ITEM2_LABEL}->{'x'}, 
                  -y => $conf->{ITEM2_LABEL}->{'y'},
                  -font => $conf->{FONT}, -size => $conf->{LABEL_FONT_SIZE},
                  -text => $LABEL2 ),"\n";

## BOX
print $svg->rect(-x => $conf->{ITEM1_BOX}->{x}, -y => $conf->{ITEM1_BOX}->{y},
                 -width => $conf->{ITEM1_BOX}->{width},
                 -height => $conf->{ITEM1_BOX}->{height},
                 -style => $conf->{BOX_STYLE}, -fill => $COLOR1),"\n";
print $svg->rect(-x => $conf->{ITEM2_BOX}->{x}, -y => $conf->{ITEM2_BOX}->{y},
                 -width => $conf->{ITEM2_BOX}->{width},
                 -height => $conf->{ITEM2_BOX}->{height},
                 -style => $conf->{BOX_STYLE}, -fill => $COLOR2),"\n";
print $svg->rect(-x => $conf->{ITEM12_BOX}->{x}, -y => $conf->{ITEM12_BOX}->{y},
                 -width => $conf->{ITEM12_BOX}->{width},
                 -height => $conf->{ITEM12_BOX}->{height},
                 -style => $conf->{BOX_STYLE}, -fill => $COLOR12),"\n";

## VALUE
print $svg->text( -x => $conf->{ITEM1_VALUE}->{'x'}, 
                  -y => $conf->{ITEM1_VALUE}->{'y'},
                  -font => $conf->{FONT}, -size => $conf->{VALUE_FONT_SIZE},
                  -text => $VALUE1 ),"\n";
print $svg->text( -x => $conf->{ITEM2_VALUE}->{'x'}, 
                  -y => $conf->{ITEM2_VALUE}->{'y'},
                  -font => $conf->{FONT}, -size => $conf->{VALUE_FONT_SIZE},
                  -text => $VALUE2 ),"\n";
print $svg->text( -x => $conf->{ITEM12_VALUE}->{'x'}, 
                  -y => $conf->{ITEM12_VALUE}->{'y'},
                  -font => $conf->{FONT}, -size => $conf->{VALUE_FONT_SIZE},
                  -text => $VALUE12 ),"\n";

## FOOTER
print $svg->footer(),"\n";
