#!/usr/bin/perl -w
use strict;

if($#ARGV != 0 ) {
    print "Usage: ./split-gff.pl <output filen name> \n\n";
    exit;
}
my $OUTPUT_FILE = $ARGV[0];

my %out;
my $GFF_VERSION = 2;
foreach my $gff_file (`ls ./*gff`) {
    chomp($gff_file);
    print STDERR 'Split ',$gff_file,"...\n";
    open(GFF,$gff_file);
    while(my $line = <GFF>) {
        chomp($line);
        if($line =~ /gff-version\s+(\d)/) { $GFF_VERSION = $1; }
        if($line =~ /^#/) { next; }
        
        if( $GFF_VERSION eq '3' ) {
            my ($seqid, $source, $type, $start, $stop, $score, 
                $strand, $phase, $attr) = split(/\t/,$line);
            push(@{$out{$type}}, $line);
        } else {
            ## GFF 2
            my ($seqname, $source, $feature, $start, $end, $score, 
                $strand, $frame, $attr) = split(/\t/,$line);
            push(@{$out{$feature}}, $line);
        }
    }
    close(GFF);
}

foreach my $tmp_tag (keys %out) {
    my $out_file = $OUTPUT_FILE.'.'.$tmp_tag.'.gff';
    open(OUT,">$out_file");
    if($GFF_VERSION eq '3') { print OUT "##gff-version\t 3\n"; }

    foreach my $tmp_line (@{$out{$tmp_tag}}) {
        print OUT $tmp_line,"\n";
    }
    close(OUT);
}
