#!/usr/bin/perl -w
use strict;

my %data;
open(EXP,"ExperimentPhenotype.190606.WS150.txt");
while(<EXP>) {
    chomp;
    my ($rnai_id, $phenotype, $exp_info, $tmp) = split(/\t/);
    $exp_info =~ s/WS150://;
    $phenotype =~ s/\s+/_/g;
    push(@{$data{$phenotype}}, $exp_info);
}
close(EXP);

foreach my $tmp_phe (keys %data) {
    next if($tmp_phe eq "WT");
    next if(length($tmp_phe) > 5);
    my $file = "rnai.".$tmp_phe;
    open(OUT,">$file");
    print STDERR "Write ",$file,"...\n";
    foreach my $tmp (@{$data{$tmp_phe}}) {
        print OUT $tmp,"\n";
    }
    close(OUT);
}
