#!/usr/bin/perl -w

## BLASTHit
## WBPepID, species, speciesProteinID, speciesProteinDescription,
## Evalue, percentLength, sourceDB

my $conf = do "../etc/wormi.pl";
my @tmp_ts = localtime(time());
my $timestamp = sprintf("%02d%02d%02d",$tmp_ts[3],$tmp_ts[4]+1,$tmp_ts[5]%100);

my $WS_HOMOL_FILE = $conf->{DIR_WORMI}. $conf->{DIR_WORMBASE_DATA}
                . $conf->{FILE_WS_HOMOLOG}.".".$conf->{WORMBASE_VER}.".txt";
my $BH_OUT_FILE = $conf->{DIR_WORMI}. $conf->{DIR_WORMI_DATA}
                . $conf->{FILE_WORMI_BLAST_HITS}.".".$timestamp."."
                . $conf->{WORMBASE_VER}.".txt";

open(HOMOL,$WS_HOMOL_FILE);
print STDERR "Read ",$WS_HOMOL_FILE,"...\n";
open(BHO,">$BH_OUT_FILE");
print STDERR "Write ",$BH_OUT_FILE,"...\n";
while(<HOMOL>) {
    chomp;
    my ($wbpepID, $protID, $Evalue, $species, $desc, $percent) = split(/\t/);
    if($species =~ /([A-Z])[a-z]+ ([a-z]+)/) { $species = $1.". ".$2; }

    print BHO "WP:",$wbpepID,"\t", $species,"\t", $protID,"\t", $desc,"\t"
            , $Evalue,"\t", $percent, "\t", $conf->{WORMBASE_VER},"\n";
}
close(BHO);
close(HOMOL);
