#!/usr/bin/perl -w

## GeneOntology
## WBGeneID, GOPrinciple, GOID, GODescription, sourceDB

my $conf = do "../etc/wormi.pl";
my @tmp_ts = localtime(time());
my $timestamp = sprintf("%02d%02d%02d",$tmp_ts[3],$tmp_ts[4]+1,$tmp_ts[5]%100);

my $WS_GO_FILE = $conf->{DIR_WORMI}. $conf->{DIR_WORMBASE_DATA}
                . sprintf($conf->{FILE_WS_GO},$conf->{WORMBASE_VER});
my $GO_OUT_FILE = $conf->{DIR_WORMI}. $conf->{DIR_WORMI_DATA}
                . $conf->{FILE_WORMI_GO}.".".$timestamp."."
                . $conf->{WORMBASE_VER}.".txt";

my %go;
my $gene;
open(GOI,$WS_GO_FILE);
print STDERR "Read ",$WS_GO_FILE,"...\n";
while(my $line = <GOI>) {
    chomp($line);
    if($line =~ /^(WBGene[0-9]+)/) { $gene = $1; }
    elsif( $line =~ s/\s*\((GO:[0-9]+)\)\s*// ) {
        my $goid = $1;
        $line =~ s/\s+([A-z_]+):\s+//;
        my $goPrinciple = $1;
        my $goDesc = $line;
        push( @{$go{$gene}}, { id => $goid, desc => $goDesc,
                                principle => $goPrinciple } );
    }
}
close(GOI);

open(GOO,">$GO_OUT_FILE");
print STDERR "Write ",$GO_OUT_FILE,"...\n";
foreach my $tmp_gene (sort keys %go) {
    foreach my $tmp_go (@{$go{$tmp_gene}}) {
        print GOO $tmp_gene, "\t", $tmp_go->{principle},"\t"
                , $tmp_go->{id},"\t", $tmp_go->{desc},"\t"
                , $conf->{WORMBASE_VER},"\n";
    }    
}
close(GOO);
